'use strict';

var NotasFiscaisController = angular.module('ListaNotaFiscalController', []);

NotasFiscaisController.controller('ListaNotaFiscalCtrl', ['$scope', '$location', '$routeParams', '$rootScope', '$filter', 'Compra', 'UploadApp', 'CacheApp', 'Categoria', 'Fonte', 'Construcao', 'Material', 'MsgBox', 'Gemini',
  ($scope, $location, $routeParams, $rootScope, $filter, Compra, UploadApp, CacheApp, Categoria, Fonte, Construcao, Material, MsgBox, Gemini) => {

    $scope.excluirNF = (NF) => {
        MsgBox.Pergunta(NF.RazaoSocial, 'Confirma exclusão ' + (NF.Tipo == 0 ? 'da' : 'do') + ' ' + NF.TipoDescricao + '?'
            , () => {
                Compra.delNotaFiscal(NF.Id,
                    (data) => {
                        if (NF.Natureza == 0) {
                            $scope.totalDebito -= NF.TotalPago;
                            $scope.totalNF += NF.TotalPago;    
                        }
                        else {
                            $scope.totalCredito -= NF.TotalPago;
                            $scope.totalNF -= NF.TotalPago;    
                        }
                        var idx = $scope.notasfiscais.indexOf(NF);
                        $scope.notasfiscais.splice(idx, 1);                        
                    });
            }
            , () => {
            }
        );
    }

    $scope.adicionarNF = (natureza,nf) => {
        CacheApp.delNotaFiscal();
        if (!nf)
            $scope.notasfiscais.push({
                Tipo: 0,
                TipoPessoa: 1,
                contabil: 1,
                Novo: true,
                Natureza: natureza == 'debito' ? 0 : 1,
                Desconto: '0',
                CategoriaSelecionada: {},
                detalhe: true,
                HtmlManterNF: `
                <manternotafiscal 
                    rd-notafiscal="item"
                    rd-obra="construcao"
                    rd-notasfiscais="notasfiscais"
                    rd-fornecedor="fornecedores">
                </manternotafiscal>`

            })
        else
            $scope.notasfiscais.push(nf)

        $scope.notasfiscais.Editando = true;
        $scope.notasfiscais.Novo = true;
    }

    $scope.alterarNF = (notafiscal) => {
        CacheApp.setNotaFiscal(notafiscal);
        notafiscal.HtmlManterNF = `
            <manternotafiscal 
                rd-notafiscal="item"
                rd-obra="construcao"
                rd-fornecedor="fornecedores">
            </manternotafiscal>
        `;
        notafiscal.detalhe = true;
        $scope.notasfiscais.Editando = notafiscal.contabil == 1;
        $scope.notasfiscais.Novo = false;
    }

    $scope.cancelarNF = (notafiscal) => {
        if (notafiscal.Novo) {
            var idx = $scope.notasfiscais.indexOf(notafiscal);
            $scope.notasfiscais.splice(idx, 1);
        }
        notafiscal.detalhe = false;
        notafiscal.HtmlManterNF = undefined
        $scope.notasfiscais.Editando = false;
        $scope.notasfiscais.Novo = false;
    }

    $scope.getNotasFiscais = () => {
        var params = {
            IdConstrucao: $scope.construcao.Id,
            Texto: $scope.pesquisa,
            TipoOperacao: $scope.NaturezaSelecionada.Id,
            Situacao: $scope.TipoSelecionada.Id,
            DataInicio: $scope.DataInicio,
            DataFim: $scope.DataFim,
            Index: $scope.paginacao.Index,
            Pages: $scope.paginacao.Pages
        }
        $scope.paginacao.Load = true;
        Compra.getNotasFiscaisPaginacao(params,
            (data) => {
                if (!$scope.notasfiscais)
                    $scope.notasfiscais = []
                data.Instance.forEach(n => {
                    n.BDI = n.BDI ? n.BDI.data[0] == 1 : false;
                    n.DescricaoNF = n.Descricao;
                    n.DataEmissao = CacheApp.getData(n.DataEmissao);
                    n.DataPagamento = CacheApp.getData(n.DataPagamento);
                    $scope.notasfiscais.push(n);
                })

                $scope.paginacao.Load = false;

                if (data.Instance && data.Instance.length > 0) {
                    $scope.totalDebito = data.Instance[0] ? data.Instance[0].Custo : 0;
                    $scope.totalCredito = data.Instance[0] ? data.Instance[0].Receita : 0;
                    $scope.totalNF = $scope.totalCredito-$scope.totalDebito;
                }

            });
    }

    $scope.aplicaFiltro = () => {
        clearTimeout($scope.timer); 
        $scope.timer = setTimeout( () => {
            $scope.inicializaPaginacao(); 
            $scope.getNotasFiscais();
        }, 1000);
    }

    $scope.inicializaPaginacao = () => {
        $scope.notasfiscais = undefined;
        $scope.paginacao = {
            Index: 0,
            Pages: 20
        };
    }

    $scope.atualizaPeriodo = () => {
        $scope.DataInicio = $scope.PeriodoSelecionado.DataInicio
        $scope.DataFim = $scope.PeriodoSelecionado.DataFim
        $scope.aplicaFiltro()
    }

    $scope.aplicaFiltroPeriodo = () => {
        Compra.getDataIniFimLancamento({IdConstrucao: $scope.construcao.Id},
            (data) => {
                $scope.listaPeriodo.find(p => p.ShowPeriodo).DataInicio = CacheApp.getData(data.Instance.DataInicio ? $filter("date")(data.Instance.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
                $scope.listaPeriodo.find(p => p.ShowPeriodo).DataFim = CacheApp.getData(data.Instance.DataFim ? $filter("date")(data.Instance.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
                $scope.PeriodoSelecionado = $scope.listaPeriodo.find(p => p.ShowPeriodo);

                $scope.DataInicio = $scope.PeriodoSelecionado.DataInicio
                $scope.DataFim = $scope.PeriodoSelecionado.DataFim
        
                $scope.aplicaFiltro();
            }
        )
    }

    $scope.getFornecedores = () => {
        $scope.aplicaFiltro();

        var params = {
            IdClienteDono: $scope.construcao.IdClienteDono
        };
        Compra.getFornecedores(params,
            (data) => {
                $scope.fornecedores = data.Instance;
            });
    }

    $scope.setNotaFiscal = () => {
        $rootScope.$broadcast('salvaNotaFiscal', {});
    }
    $scope.$on('refreshListaNotasFiscais', (event, args) => {
        if (!args.IdFornecedorCliente)
            Compra.getFornecedores({IdClienteDono: $scope.construcao.IdClienteDono},
                (forn) => {
                    $scope.fornecedores = forn.Instance;
                });

        $scope.aplicaFiltroPeriodo()
    });

    $scope.$on('atualizaListaNotasFiscais', (event, args) => {
        if (args.IdNotaFiscal == 0) return;
        Compra.getNotasFiscais($scope.construcao.Id, args.IdNotaFiscal,
            (data) => {
                var nfs = data.Instance;
                $scope.totalDebito = nfs[0] ? nfs[0].Custo : 0;
                $scope.totalCredito = nfs[0] ? nfs[0].Receita : 0;
                $scope.totalNF = $scope.totalCredito-$scope.totalDebito;
                var nfsAtual = $scope.notasfiscais.filter(n => n.Id == nfs[0].Id)[0];
                nfs.forEach(n => {
                    n.DataEmissao = CacheApp.getData(n.DataEmissao);
                    n.DataPagamento = CacheApp.getData(n.DataPagamento);

                    n.BDI = n.BDI ? n.BDI.data[0] == 1 : false;
                    nfsAtual.DataPagamento = n.DataPagamento;
                    nfsAtual.BDI = n.BDI;
                    nfsAtual.Custo = n.Custol;
                    nfsAtual.Desconto = n.Desconto;
                    nfsAtual.IdCategoria = n.IdCategoria;
                    nfsAtual.IdFonte = n.IdFonte ? n.IdFonte.toString() : n.IdFonte;
                    nfsAtual.IdSituacao = n.IdSituacao ? n.IdSituacao.toString() : n.IdSituacao;
                    nfsAtual.Natureza = n.Natureza ? n.Natureza.toString() : n.Natureza;
                    nfsAtual.NomeFonte = n.NomeFonte;
                    nfsAtual.NomeCategoria = n.NomeCategoria;
                    nfsAtual.NomeSituacao = n.NomeSituacao;
                    nfsAtual.Numero = n.Numero;
                    nfsAtual.DescricaoNF = n.Descricao;
                    nfsAtual.QtdParcela = n.QtdParcela;
                    nfsAtual.Receita = n.Receita;
                    nfsAtual.Saldo = n.Saldo;
                    nfsAtual.Serie = n.Serie;
                    nfsAtual.Tipo = n.Tipo;
                    nfsAtual.TipoDescricao = n.TipoDescricao;
                    nfsAtual.TotalItens = n.TotalItens;
                    nfsAtual.TotalPago = n.TotalPago;
                    nfsAtual.TotalPendente = n.TotalPendente;
                    nfsAtual.TotalQtdItens = n.TotalQtdItens;
                    nfsAtual.Valor = n.Valor;
                    nfsAtual.ValorDesconto = n.ValorDesconto;
                    nfsAtual.Vencido = n.Vencido;
                    nfsAtual.OrdemCompra = n.OrdemCompra;
                    nfsAtual.IdFornecedorCliente = n.IdFornecedorCliente;
                    nfsAtual.Cnpj = n.Cnpj;
                    nfsAtual.RazaoSocial = n.RazaoSocial;
                    nfsAtual.OrdemCompra = n.OrdemCompra;
                    nfsAtual.OrdemCompraDescricao = n.OrdemCompraDescricao;
                });
                nfsAtual.detalhe = args.Editando ? args.Editando : false;
                $scope.notasfiscais.Editando = args.Editando ? args.Editando : false;// false;
                nfsAtual.exibeFadeInOutSave = true;
                $rootScope.$broadcast('refreshOrdemCompraSolta', {});
                setInterval(() => {
                    nfsAtual.exibeFadeInOutSave = false;
                }, 10000);
            });
    });

    $scope.$on('atualizaListaNotasFiscaisItemApropriado', (event, args) => {
        if (args.IdNotaFiscal == 0) return;
        Compra.getNotasFiscais($scope.construcao.Id, args.IdNotaFiscal,
            (data) => {
                var nfs = data.Instance;
                $scope.totalDebito = nfs[0] ? nfs[0].Custo : 0;
                $scope.totalCredito = nfs[0] ? nfs[0].Receita : 0;
                $scope.totalNF = $scope.totalCredito-$scope.totalDebito;
                var nfsAtual = $scope.notasfiscais.filter(n => n.Id == nfs[0].Id)[0];
                nfs.forEach(n => {
                    nfsAtual.Custo = n.Custol;
                    nfsAtual.Desconto = n.Desconto;
                    nfsAtual.QtdParcela = n.QtdParcela;
                    nfsAtual.Receita = n.Receita;
                    nfsAtual.Saldo = n.Saldo;
                    nfsAtual.TotalItens = n.TotalItens;
                    nfsAtual.TotalPago = n.TotalPago;
                    nfsAtual.TotalPendente = n.TotalPendente;
                    nfsAtual.TotalQtdItens = n.TotalQtdItens;
                    nfsAtual.Valor = n.Valor;
                    nfsAtual.ValorDesconto = n.ValorDesconto;
                    nfsAtual.Vencido = n.Vencido;
                });
                nfsAtual.detalhe = true;
            });
    });

    $scope.downloadNF = (notafiscal) => {
        window.open(notafiscal.Arquivo, '_blank');
    }

    $scope.downloadAllNF = (obra) => {
        Construcao.getArquivoNotaFiscalObra({IdConstrucao: obra.Id},
            (file) => {
                const downloadLink = document.createElement('a')
                document.body.appendChild(downloadLink)
                downloadLink.href = `data:text/plain;base64,${file.Instance}`
                downloadLink.target = '_self'
                downloadLink.download = `${obra.Titulo}.zip`
                downloadLink.click()
            }
        )
    }

    $scope.lancamentoNF = (notafiscal) => {
        CacheApp.setNotaFiscal(notafiscal);
        $location.path('/listarealizar');
    }

    $scope.adicionaParcelas = (notafiscal) => {
        notafiscal.fromLista = true;
        CacheApp.setNotaFiscal(notafiscal);
        
        $('#BoxParcela').modal('show');
    }

    $scope.blocoDeImagens = () => {

        $scope.exibirDropZone = true;
        $scope.listaXML = [];
        $scope.getEtapasNF();
        $scope.getListaCategoriaNF();
        $scope.getListaFonteNF();
        const inputElement = document.getElementById("dropZoneInputXML");
        const dropZoneElement = inputElement.closest(".drop-zone");

        dropZoneElement.removeEventListener("click", (e)=>{})

        dropZoneElement.addEventListener("click", (e) => {
            inputElement.click();
        });

        inputElement.addEventListener("change", (e) => {
            if (inputElement.files.length) {
                const totImagens = inputElement.files.length;
                var files = inputElement.files;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaXML.some(c => c.file == files[i]))
                        continue;

                    $scope.listaXML.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }
                document.getElementById("dropZoneInputXML").value = "";

                $scope.saveList = true;
                $scope.$apply();
            }
        });

        dropZoneElement.addEventListener("dragover", (e) => {
            e.preventDefault();
            dropZoneElement.classList.add("drop-zone--over");
        });

        ["dragleave", "dragend"].forEach((type) => {
            dropZoneElement.addEventListener(type, (e) => {
                dropZoneElement.classList.remove("drop-zone--over");
            });
        });

        dropZoneElement.addEventListener("drop", (e) => {
            e.preventDefault();

            if (e.dataTransfer.files.length) {
                var files = e.dataTransfer.files;
                const totImagens = files.length;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaXML.some(c => c.file == files[i]) || files[i].name.toLowerCase().indexOf('.xml') < 0)
                        continue;
                    
                    $scope.listaXML.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }

                if ($scope.listaXML.length > 0) {
                    $scope.saveList = true;
                    $scope.$apply();
                }
            }

            dropZoneElement.classList.remove("drop-zone--over");
        });
    }

    $scope.salvarListaXML = () => {

        function salvaXml(xmlFile, callBackFunction) {
            xmlFile.progress = 0;
            UploadApp.UploadXmlNotaFiscal(xmlFile,
                (progress) => {
                    xmlFile.progress = progress;
                },
                (result) => {
                    xmlFile.Enviado = true;
                    xmlFile.Sucesso = result.Code == 0;
                    xmlFile.Mensagem = result.Description;
                    callBackFunction(result);
                },
                (error) => {
                }
            );
        }

        function salvaXmlRecursivo(idx,xmls,callBack) {
            if (xmls.length == idx)
                callBack(xmls)
            else {
                salvaXml(xmls[idx], () => {
                    salvaXmlRecursivo(idx+1,xmls,(data)=>{
                        callBack(data);
                    });
                });
            }
        }

        $scope.listaXML.forEach(l => {
            l.TipoLancamento = $scope.TipoNFSelecionada.Id
            l.Fonte = $scope.FonteNFSelecionada.IdFonte
            l.Categoria = $scope.CategoriaNFSelecionada.IdCategoria
            if ($scope.EtapaNFSelecionada.Id != 0)
                l.IdEtapa = $scope.EtapaNFSelecionada.Id
            if ($scope.ComposicaoNFSelecionada.Id != 0)
                l.IdComposicao = $scope.ComposicaoNFSelecionada.Id
        })

        salvaXmlRecursivo(0,$scope.listaXML,(data) => {
            $scope.saveList = false;
            $scope.aplicaFiltroPeriodo();
        });
    }

    $scope.getListaCategoriaNF = () => {
        Categoria.getListaCategoria($scope.construcao.IdClienteDono,
            (data) => {
                $scope.listaCategoriaNF = data.Instance;
                $scope.listaCategoriaNF.unshift({IdCategoria: 0, Nome: 'Sem Categoria'});
                $scope.CategoriaNFSelecionada = {IdCategoria: 0};
            });
    }

    $scope.getListaFonteNF = () => {
        var params = {IdClienteAdmin: $scope.construcao.IdClienteDono}
        Fonte.getListaFonte(params,
            (data) => {
                $scope.listaFonteNF = data.Instance;
                $scope.listaFonteNF.unshift({IdFonte: 0, Nome: 'Sem Fonte'});
                $scope.FonteNFSelecionada = {IdFonte: 0};
            });
    }

    $scope.getEtapasNF = () => {
        $scope.etapasNF = [];
        $scope.composicoesNF = [{Id: 0, Ordem: '', Nome: 'Sem Composição'}];
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {
                $scope.etapasNF = data.Instance;
                $scope.etapasNF.unshift({Id: 0, Ordem: '', Descricao: 'Sem Etapa'});
                $scope.EtapaNFSelecionada = {Id: 0};
                $scope.ComposicaoNFSelecionada = {Id: 0};
            });
    }

    $scope.getComposicoesNF =  (item) => {
        if (!item || item.Id == 0) {
            $scope.composicoesNF = [{Id: 0, Ordem: '', Nome: 'Sem Composição'}];
            return;
        }
        item.IdEtapa = item.Id;
        Material.getListaMaterialAvanco(
            $scope.construcao.Id,
            item.IdEtapa,
            '',
             (data) => {
                $scope.composicoesNF = data.Instance;
                $scope.composicoesNF.unshift({Id: 0, Ordem: '', Nome: 'Sem Composição'});
                $scope.ComposicaoNFSelecionada = {Id: 0};
            });
    }

    $scope.adicionarNotaFiscal = (item) => {
        if (!$scope.pagamentos)
            $scope.pagamentos = {};
        if (!$scope.pagamentos.Ids)
            $scope.pagamentos.Ids = [];
        if ($scope.pagamentos.Ids.indexOf(item.Id) < 0)
            $scope.pagamentos.Ids.push(item.Id);
        else
            $scope.pagamentos.Ids.splice($scope.pagamentos.Ids.indexOf(item.Id), 1);

        item.selecionado = !item.selecionado;
        $scope.salvaSelecao = $scope.pagamentos.Ids.length > 0;
        if (!$scope.listaFonteNF)
            $scope.getListaFonteNF();
    }

    $scope.setPagamentoSelecao = () => {
        var naturezaLancamento = `<br /><label style="margin-top: 10px; max-width: 100%; font-size: 30px;">Baixa nos Lançamento</label>`;

        swal({
            title: 'Data Pagamento Parcela',
            html: '<input type="date" class="input-lg" id="DataPagamento" datasafari />' +
                    naturezaLancamento,
            showCancelButton: true,
            confirmButtonColor: '#263143',
            cancelButtonColor: '#F6A000',
            confirmButtonText: 'Salvar',
            cancelButtonText: "Cancelar",
            onOpen: () => {
                $('#DataPagamento').val( $filter("date")(Date.now(), 'yyyy-MM-dd') );//item.Data;
            }
          }).then((result) => {
            if (result.value) {
                $scope.pagamentos.IdFonte = $('#FontePagamento').val();
                $scope.pagamentos.DataPagamento = CacheApp.getData($('#DataPagamento').val()+'T03:05:00Z');
                Compra.setParcelasPagas($scope.pagamentos,
                    (data) => {
                        $scope.pagamentos.Ids = [];
                        $scope.salvaSelecao = false;
                        $scope.aplicaFiltro()
                    }
                );
            }
          });
    }

    $scope.blocoCupomFiscal = () => {

        $scope.exibirDropZoneCupomFiscal = true;
        $scope.listaCupom = [];
        const inputElement = document.getElementById("dropZoneInputIMG");
        const dropZoneElement = inputElement.closest(".drop-zone");

        dropZoneElement.removeEventListener("click", (e)=>{})

        dropZoneElement.addEventListener("click", (e) => {
            inputElement.click();
        });

        inputElement.addEventListener("change", (e) => {
            if (inputElement.files.length) {
                const totImagens = inputElement.files.length;
                var files = inputElement.files;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaCupom.some(c => c.file == files[i])
                        || ['pdf','jpg','jpeg','png'].indexOf(files[i].name.split('.').pop().toLowerCase()) < 0
                    )
                        continue;

                    $scope.listaCupom.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }
                document.getElementById("dropZoneInputIMG").value = "";

                $scope.saveCupom = true;
                $scope.$apply();
                $scope.leituraCupom();
            }
        });

        dropZoneElement.addEventListener("dragover", (e) => {
            e.preventDefault();
            dropZoneElement.classList.add("drop-zone--over");
        });

        ["dragleave", "dragend"].forEach((type) => {
            dropZoneElement.addEventListener(type, (e) => {
                dropZoneElement.classList.remove("drop-zone--over");
            });
        });

        dropZoneElement.addEventListener("drop", (e) => {
            e.preventDefault();

            if (e.dataTransfer.files.length) {
                var files = e.dataTransfer.files;
                const totImagens = files.length;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaCupom.some(c => c.file == files[i])
                        || ['jpg','jpeg','png'].indexOf(files[i].name.split('.').pop().toLowerCase()) < 0
                    )
                        continue;
                    
                    $scope.listaCupom.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }

                if ($scope.listaCupom.length > 0) {
                    $scope.saveCupom = true;
                    $scope.$apply();
                    $scope.leituraCupom();
                }
            }

            dropZoneElement.classList.remove("drop-zone--over");
        });
    }

    $scope.leituraCupom = () => {
        var item = $scope.listaCupom[0];
        Gemini.setPromptIA({Texto: `Leitura de imagem para lançamento financeiro. Obra: ${item.IdConstrucao}; File: ${item.Nome}`, IdCliente: $scope.sessao && $scope.sessao.IdCliente ? $scope.sessao.IdCliente : item.IdClienteDono}, () => {}) 
        UploadApp.getLancamentoFromImage(item,
            (progress) => {
                item.progress = progress;
            },
            (result) => {
                item.Sucesso = result.Code == 0;
                if (item.Sucesso) {
                    $scope.saveCupom = false;
                    $scope.exibirDropZoneCupomFiscal = false;
                    item.Mensagem = 'Comprovante de pagamento lido com sucesso';
                    var data = result.Instance;
                    var nf = {
                        Tipo: 2,
                        TipoPessoa: 1,
                        contabil: 1,
                        naoVincula: false,
                        Novo: true,
                        Cnpj: data.CnpjCpf,
                        RazaoSocial: data.NomeRazaoSocial,
                        Numero: data.Numero,
                        Serie: '',
                        Natureza: 0,
                        DataEmissao: CacheApp.getData(data.DataPagamento),
                        DataPagamento: CacheApp.getData(data.DataPagamento),
                        Desconto: '0',
                        Valor: data.Valor,
                        DescricaoNF: data.Descricao,
                        CategoriaSelecionada: {},
                        ListaItens: data.Itens,
                        detalhe: true,
                        file: item.file,
                        HtmlManterNF: `
                        <manternotafiscal 
                            rd-notafiscal="item"
                            rd-obra="construcao"
                            rd-notasfiscais="notasfiscais"
                            rd-fornecedor="fornecedores">
                        </manternotafiscal>`
                    }

                    $scope.notasfiscais = $scope.notasfiscais.filter(n => !n.Novo);
                    $scope.adicionarNF(null,nf)
                }
                else {
                    item.Mensagem = result.Description;
                }
            },
            (error) => {}

        );
    }

    $scope.blocoPlanilha = () => {
        if ($scope.sessao.TipoPlano == 3) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.exibirDropZonePlanilha = true;
        $scope.listaPlanilha = [];
        const inputElement = document.getElementById("dropZoneInputXLSX");
        const dropZoneElement = inputElement.closest(".drop-zone");

        dropZoneElement.removeEventListener("click", (e)=>{})

        dropZoneElement.addEventListener("click", (e) => {
            inputElement.click();
        });

        inputElement.addEventListener("change", (e) => {
            if (inputElement.files.length) {
                const totImagens = inputElement.files.length;
                var files = inputElement.files;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaPlanilha.some(c => c.file == files[i]))
                        continue;

                    $scope.listaPlanilha.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }
                document.getElementById("dropZoneInputXLSX").value = "";

                $scope.savePlanilha = true;
                $scope.$apply();
                $scope.leituraPlanilha();
            }
        });

        dropZoneElement.addEventListener("dragover", (e) => {
            e.preventDefault();
            dropZoneElement.classList.add("drop-zone--over");
        });

        ["dragleave", "dragend"].forEach((type) => {
            dropZoneElement.addEventListener(type, (e) => {
                dropZoneElement.classList.remove("drop-zone--over");
            });
        });

        dropZoneElement.addEventListener("drop", (e) => {
            e.preventDefault();

            if (e.dataTransfer.files.length) {
                var files = e.dataTransfer.files;
                const totImagens = files.length;
                for (var i = 0; i<totImagens; i++){
                    if ($scope.listaPlanilha.some(c => c.file == files[i])
                        || ['xlsx','xls','csv'].indexOf(files[i].name.split('.').pop().toLowerCase()) < 0
                    )
                        continue;
                    
                    $scope.listaPlanilha.push({
                        IdConstrucao: $scope.construcao.Id, 
                        IdClienteDono: $scope.construcao.IdClienteDono, 
                        Nome: files[i].name, 
                        file: files[i]
                    });
                }

                if ($scope.listaPlanilha.length > 0) {
                    $scope.savePlanilha = true;
                    $scope.$apply();
                    $scope.leituraPlanilha();
                }
            }

            dropZoneElement.classList.remove("drop-zone--over");
        });
    }

    $scope.leituraPlanilha = () => {
        var item = $scope.listaPlanilha[0];
        UploadApp.UploadPlanilhaNotaFiscal(item,
            (progress) => {
                item.progress = progress;
            },
            (result) => {
                item.Sucesso = result.Code == 0;
                if (item.Sucesso) {
                    $scope.savePlanilha = false;
                    $scope.aplicaFiltroPeriodo();
                }
                else {
                    item.Mensagem = result.Description;
                }
            },
            (error) => {}
        );
    }

    $scope.abreLink = (link) => {
        window.open(link,'_blank')
    }

    $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: 'GET_FINANCEIRO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.exibirDropZone = false
            $scope.notasfiscais = []
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.exibirDropZone = false
        $scope.notasfiscais = undefined
        $scope.construcao = obra
        CacheApp.setConstrucao($scope.construcao)

        $scope.listaRelatorio = []
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0)
        
        $scope.totalDebito = 0
        $scope.totalCredito = 0
        $scope.totalNF = 0

        Compra.getDataIniFimLancamento({IdConstrucao: obra.Id},
            (data) => {
                $scope.listaPeriodo.find(p => p.ShowPeriodo).DataInicio = CacheApp.getData(data.Instance.DataInicio ? $filter("date")(data.Instance.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
                $scope.listaPeriodo.find(p => p.ShowPeriodo).DataFim = CacheApp.getData(data.Instance.DataFim ? $filter("date")(data.Instance.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
                $scope.PeriodoSelecionado = $scope.listaPeriodo.find(p => p.ShowPeriodo);

                $scope.DataInicio = $scope.PeriodoSelecionado.DataInicio
                $scope.DataFim = $scope.PeriodoSelecionado.DataFim
        
                $scope.getFornecedores()
            }
        )
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
        if (!$scope.openObra && $scope.construcao.Novo)
            $scope.loadObra()
    }

    $scope.adicionarObra = () => {
        if ($scope.sessao.TipoPlano == 3 && $scope.construcoes && $scope.construcoes.length > 2) {
            CacheApp.msgBoxAcessoPremium();
            return;
        }

        $scope.construcao = { Tipo: 0, Dono: true, Novo: true }
        $scope.editarObra()
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra()
    })

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.ObraSelecionada = $scope.construcoes.filter(c => c.Id == $scope.ObraSelecionada.Id)[0]
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }

                // $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else {
                $scope.ObraSelecionada = undefined
                $scope.construcao = undefined
                $scope.notasfiscais = []
            }
        })
    }

    $scope.AcessoAndroid($routeParams,  (sim) => {
        $scope.AcessoMobile = sim;
        $scope.sessao = CacheApp.getSessao()

        $scope.ListaNatureza = [
            {Id: 2, Descricao: 'Crédito e Débito'},
            {Id: 0, Descricao: 'Débito'},
            {Id: 1, Descricao: 'Crédito'}
        ];

        $scope.ListaTipo = [
            {Id: 0, Descricao: 'Todas'},
            {Id: 1, Descricao: 'Pago/Recebido'},
            {Id: 2, Descricao: 'Vencido'},
            {Id: 3, Descricao: 'Em Aberto'}
        ];

        $scope.listaOrdem = [
            {Id: 0, Descricao: 'Data Registro', Field: 'Id'},
            {Id: 1, Descricao: 'Data Vencimento', Field: 'DataPagamento'},
            {Id: 2, Descricao: 'Empresa', Field: 'RazaoSocial'},
            {Id: 3, Descricao: 'Número', Field: 'Numero'},
            {Id: 4, Descricao: 'Valor Nota', Field: 'ValorDesconto'},
            {Id: 5, Descricao: 'Valor Pago', Field: 'TotalPago'},
            {Id: 6, Descricao: 'Valor Pendente', Field: 'TotalPendente'},
            {Id: 7, Descricao: 'Categoria', Field: 'NomeCategoria'},
            {Id: 8, Descricao: 'Fonte', Field: 'NomeFonte'}
        ];

        $scope.listaTipoNF = [
            {Id: 0, Descricao: 'Débito'},
            {Id: 1, Descricao: 'Crédito'}
        ];
        $scope.TipoNFSelecionada = {Id: 0};

        $scope.listaOrdemPos = [
            {Id: 0, Descricao: 'Crescente'},
            {Id: 1, Descricao: 'Decrescente'}
        ];
        $scope.OrdemPosSelecionado = {Id: 1};

        $scope.NaturezaSelecionada = {Id: 2, Descricao: 'Todos'};
        $scope.TipoSelecionada = {Id: 0, Descricao: 'Todos'};
        $scope.ordemSelecionado = {Id: 0, Descricao: 'Data Registro', Field: 'Id'};
        $scope.fieldOrder = $scope.ordemSelecionado.Field;

        $scope.reverse = true;

        $scope.listaPeriodo = [
            {Id: 0, Descricao: 'Personalizado', DataInicio: new Date(Date.now()), DataFim: new Date(Date.now()), ShowPeriodo: true},
            {Id: 1, Descricao: 'Últimos 15 dias', DataInicio: new Date(Date.now() - 15 * 24 * 60 * 60 * 1000), DataFim: new Date(Date.now())},
            {Id: 2, Descricao: 'Últimos 30 dias', DataInicio: new Date(Date.now() - 30 * 24 * 60 * 60 * 1000), DataFim: new Date(Date.now())},
            {Id: 3, Descricao: 'Últimos 60 dias', DataInicio: new Date(Date.now() - 60 * 24 * 60 * 60 * 1000), DataFim: new Date(Date.now())},
        ];

        // $scope.PeriodoSelecionado = $scope.listaPeriodo.find(p => p.Id == 0);


        CacheApp.delNotaFiscal();
        $scope.reportList = [
            { Id: 0, Descricao: 'Relatório Analítico de Lançamentos', Permissao: 'GET_RELATCUSTO', Url: 'relatoriocustoobra' },
            { Id: 1, Descricao: 'Relatório Sintético de Lançamentos', Permissao: 'GET_RELATCUSTO', Url: 'custoobrasintetico' },
            { Id: 2, Descricao: 'Relatório Orçado X Realizado', Permissao: 'GET_ORCAMENTOCUSTO', Url: 'relatorioorcadocustoobra' },
            { Id: 3, Descricao: 'Relatório BDI', Permissao: 'GET_RELATORIOBDI', Url: 'relatoriobdi' },
            { Id: 4, Descricao: 'Relatório de Lançamentos Por Categoria', Permissao: 'GET_RELATORIOCUSTOCATEGORIA', Url: 'relatoriocustocategoria' },
            { Id: 5, Descricao: 'Relatório Contas a Pagar', Permissao: 'GET_RELATORIODEBITOPERIODO', Url: 'relatoriodebitoperiodo' },
            { Id: 6, Descricao: 'Relatório Contas a Receber', Permissao: 'GET_RELATORIOCREDITOPERIODO', Url: 'relatoriocreditoperiodo' },
        ];


        if ($routeParams.from == 'geral') {
            $scope.loadObra()
        }
        else {
            $scope.listaRelatorio = $scope.reportList
            $scope.construcao = CacheApp.getConstrucao()
            $scope.getFornecedores()
        }

    });

  }]);
